#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double factorial(int n);
double dbinom(int x, int n, float p);
double pbinom(int x, int n, float p);

//--------------------------------------------------
int main(int argc, char *argv[]) {
  int x,n;
  float p;
  
  if (argc < 4) {
    puts("Devi dare x, n e p");
    return(0);
  }

  x = atoi(argv[1]);
  n = atoi(argv[2]);
  p = atof(argv[3]);
  
  if (n<1) {
    puts("n deve essere positivo");
    return(0);
  }
  if (x<0 || x>n) {
    puts("x deve essere compreso fra 0 e n");
    return(0);
  }
  if (p<0 || p>1) {
    puts("1 deve essere compreso fra 0 e 1");
    return(0);
  }
  
  printf("x=%d, n=%d, p=%.3f\n", x, n, p);

  printf("f(x) = %.3e\n", dbinom(x, n, p));
  printf("F(x) = %.3e\n", pbinom(x, n, p));
  
  return(0);
}

//-------------------------------------------
double factorial(int n) {
  int i;
  double p=1;

  if (n < 2) return(1);
		 
  for (i=1; i<=n; i++) {
    p *=  (double) i;
  }

  return(p);  
}

//----------------------------------------
double dbinom(int x, int n, float p) {
  double f;

  f = factorial(n) / (factorial(x)*factorial(n-x)) *
    pow(p, (float) x) * pow(1-p, (float) n-x);

  return(f); 
}

//----------------------------------------
double pbinom(int x, int n, float p) {
  double P=0;
  int i;

  for(i=0; i<=x; i++) {
    P += dbinom(i, n, p);
  }

  return(P); 
}
