#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double factorial(int n);
double dbinom(int x, int n, float p);

//--------------------------------------------------
int main(int argc, char *argv[]) {
  int n, i;
  float p;
  double m, m2, var, std;
  
  if (argc < 3) {
    puts("Devi dare n e p");
    return(0);
  }

  n = atoi(argv[1]);
  p = atof(argv[2]);
  
  if (n<1) {
    puts("n deve essere positivo");
    return(0);
  }
  if (p<0 || p>1) {
    puts("1 deve essere compreso fra 0 e 1");
    return(0);
  }
  
  printf("n=%d, p=%.3f\n", n, p);

  for(i=0, m=0., m2=0.; i <= n; i++) {
    m += (double) i * dbinom(i, n, p);
    //    printf("%d,  %f,  %f\n", i,  dbinom(i, n, p), m);    
    m2 += (double) i * (float) i * dbinom(i, n, p);
  }
  var = m2 - m*m;
  std = sqrt(var);
  
  printf("E[X] = %.3f,  sigma(X) = %.3f\n", m, std);
  
  return(0);
}

//-------------------------------------------
double factorial(int n) {
  int i;
  double p=1;

  if (n < 2) return(1);
		 
  for (i=1; i<=n; i++) {
    p *=  (double) i;
  }

  return(p);  
}

//----------------------------------------
double dbinom(int x, int n, float p) {
  double f;

  f = factorial(n) / (factorial(x)*factorial(n-x)) *
    pow(p, (float) x) * pow(1-p, (float) n-x);

  return(f); 
}

