#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

void setRandomSeed( unsigned RandomSeed);
int SimulaProve(int n, float p);

//--------------------------------------------------
int main(int argc, char *argv[]) {
  int n;
  float p;

  if (argc < 3) {
    puts("Devi dare n e p");
    return(0);
  }

  n = atoi(argv[1]);
  p = atof(argv[2]);
  
  if (n<1) {
    puts("n deve essere positivo");
    return(0);
  }
  if (p<0 || p>1) {
    puts("1 deve essere compreso fra 0 e 1");
    return(0);
  }
  
  // printf("n=%d, p=%.3f\n", n, p);

  setRandomSeed(0);
  
  printf(" %d\n", SimulaProve(n, p) );
  
  return(0);
}

//----------------------------------------
int SimulaProve(int n, float p) {
  int i, s=0;
  float runif;
  
  for(i=0; i<n; i++) {
     runif = (float) rand() / (float) RAND_MAX;
     if(runif <= p) s += 1;        
  }
  return(s);
}

//---------------------------------------------------
void setRandomSeed( unsigned RandomSeed) {
  
  // se RandomSeed==0  usa il tempo del computer
  // altrimenti usa il numero passato come argomento
  // Nota: RICHIEDE gli header stdlib.h e time.h
  
  time_t t;

  if (RandomSeed == 0 ) {     // se == 0 si usa il tempo
     RandomSeed = (unsigned) time(&t);
  }

  //  printf("seed %u\n", RandomSeed );
  srand( RandomSeed );
}
